Index: lib/spatial/mapbuilder/lib/tool/xsl/GetMap.xsl
===================================================================
--- lib/spatial/mapbuilder/lib/tool/xsl/GetMap.xsl	(revision 4306)
+++ lib/spatial/mapbuilder/lib/tool/xsl/GetMap.xsl	(revision 4307)
@@ -1,99 +1,14 @@
-<?xml version="1.0" encoding="ISO-8859-1"?>
+<?xml version="1.0"?>
+<xsl:stylesheet xmlns:wmc="http://www.opengis.net/context" xmlns:mb="http://mapbuilder.sourceforge.net/mapbuilder" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xlink="http://www.w3.org/1999/xlink" version="1.0"><xsl:output method="xml" omit-xml-declaration="yes"/><xsl:strip-space elements="*"/><xsl:param name="bbox"/><xsl:param name="width"/><xsl:param name="height"/><xsl:param name="srs"/><xsl:param name="version"/><xsl:param name="format">image/gif</xsl:param><xsl:template match="Layer"><xsl:variable name="styleParam"/><xsl:variable name="visibility"/><xsl:variable name="mapRequest"><xsl:choose><xsl:when test="starts-with($version, '1.0')">
 
-<!--
-
-Description: transforms a WMS Layer node into an XML structure that contains
-
-             the URL for the GetMap request for both context docs and WMS caps.
-
-Author:      adair
-
-Licence:     LGPL as specified in http://www.gnu.org/copyleft/lesser.html .
-
-
-
-$Id$
-
-$Name$
-
--->
-
-
-
-<xsl:stylesheet version="1.0" 
-
-    xmlns:wmc="http://www.opengis.net/context" 
-
-    xmlns:mb="http://mapbuilder.sourceforge.net/mapbuilder" 
-
-    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
-
-    xmlns:xlink="http://www.w3.org/1999/xlink">
-
-
-
-  <xsl:output method="xml"/>
-
-  <xsl:strip-space elements="*"/>
-
-  <!--
-
-  <xsl:include href="ogcMapImgObjects.xsl" />
-
-  -->
-
-
-
-  <xsl:param name="bbox"/>
-
-  <xsl:param name="width"/>
-
-  <xsl:param name="height"/>
-
-  <xsl:param name="srs"/>
-
-  <xsl:param name="version"/>
-
-  <xsl:param name="format">image/gif</xsl:param>
-
-  
-
-  <xsl:template match="Layer">
-
-    <xsl:variable name="styleParam"/>
-
-    <xsl:variable name="visibility"/>
-
-    <xsl:variable name="mapRequest">
-
-      <xsl:choose>
-
-        <xsl:when test="starts-with($version, '1.0')">
-
             WMTVER=<xsl:value-of select="$version"/>&amp;REQUEST=map
 
-        </xsl:when>            
+        </xsl:when><xsl:otherwise>
 
-        <xsl:otherwise>
-
             VERSION=<xsl:value-of select="$version"/>&amp;REQUEST=GetMap
 
-        </xsl:otherwise>
+        </xsl:otherwise></xsl:choose></xsl:variable><GetMap><mb:QueryString><xsl:variable name="src"><xsl:value-of select="$mapRequest"/>
 
-      </xsl:choose>
-
-    </xsl:variable>
-
-
-
-    <GetMap>
-
-      <mb:QueryString>
-
-        <xsl:variable name="src">    
-
-            <xsl:value-of select="$mapRequest"/>
-
    &amp;SRS=<xsl:value-of select="$srs"/>
 
   &amp;BBOX=<xsl:value-of select="translate($bbox,' ',',')"/>
@@ -110,128 +25,24 @@
 
 &amp;TRANSPARENT=TRUE
 
-<!--	
+</xsl:variable><xsl:value-of select="translate(normalize-space($src),' ', '' )" disable-output-escaping="no"/></mb:QueryString></GetMap></xsl:template><xsl:template match="wmc:Layer"><xsl:param name="version"><xsl:value-of select="wmc:Server/@version"/></xsl:param><xsl:variable name="format"><xsl:choose><xsl:when test="wmc:FormatList"><xsl:value-of select="wmc:FormatList/wmc:Format[@current='1']"/></xsl:when><xsl:otherwise>image/gif</xsl:otherwise></xsl:choose></xsl:variable><xsl:variable name="styleParam"><xsl:choose><xsl:when test="wmc:StyleList/wmc:Style[@current='1']/wmc:SLD">
 
-  //TBD: these still to be properly handled 
+          SLD=<xsl:value-of select="wmc:StyleList/wmc:Style[@current='1']/wmc:SLD/wmc:OnlineResource/@xlink:href"/></xsl:when><xsl:when test="wmc:StyleList/wmc:Style[@current='1']/wmc:SLD/wmc:StyledLayerDescriptor">
 
-  //also sld support
+          SLD=<xsl:value-of select="wmc:StyleList/wmc:Style[@current='1']/wmc:SLD/wmc:StyledLayerDescriptor"/></xsl:when><xsl:when test="wmc:StyleList/wmc:Style[@current='1']/wmc:SLD/wmc:FeatureTypeStyle">
 
-  if (this.transparent) src += '&' + 'TRANSPARENT=' + this.transparent;
+          SLD=<xsl:value-of select="wmc:StyleList/wmc:Style[@current='1']/wmc:SLD/wmc:FeatureTypeStyle"/></xsl:when><xsl:otherwise>
 
-	if (this.bgcolor) src += '&' + 'BGCOLOR=' + this.bgcolor;
+          STYLES=<xsl:value-of select="wmc:StyleList/wmc:Style[@current='1']/wmc:Name"/></xsl:otherwise></xsl:choose></xsl:variable><xsl:variable name="visibility"><xsl:choose><xsl:when test="@hidden='1'">hidden</xsl:when><xsl:otherwise>visible</xsl:otherwise></xsl:choose></xsl:variable><xsl:variable name="mapRequest"><xsl:choose><xsl:when test="starts-with($version, '1.0')">
 
-	//if (this.exceptions) src += '&' + 'EXCEPTIONS=' + this.exceptions;
-
-	if (this.vendorstr) src += '&' + this.vendorstr;
-
-  // -->
-
-        </xsl:variable>
-
-        <xsl:value-of select="translate(normalize-space($src),' ', '' )" disable-output-escaping="no"/>
-
-      </mb:QueryString>
-
-    </GetMap>
-
-  </xsl:template>
-
-
-
-  <xsl:template match="wmc:Layer">
-
-    <xsl:param name="version">
-
-        <xsl:value-of select="wmc:Server/@version"/>    
-
-    </xsl:param>
-
-    <xsl:variable name="format">
-
-      <xsl:choose>
-
-        <xsl:when test="wmc:FormatList"><xsl:value-of select="wmc:FormatList/wmc:Format[@current='1']"/></xsl:when>
-
-        <xsl:otherwise>image/gif</xsl:otherwise>
-
-      </xsl:choose>
-
-    </xsl:variable>
-
-    <xsl:variable name="styleParam">
-
-      <xsl:choose>
-
-        <xsl:when test="wmc:StyleList/wmc:Style[@current='1']/wmc:SLD">
-
-          SLD=<xsl:value-of select="wmc:StyleList/wmc:Style[@current='1']/wmc:SLD/wmc:OnlineResource/@xlink:href"/>
-
-        </xsl:when>
-
-        <xsl:when test="wmc:StyleList/wmc:Style[@current='1']/wmc:SLD/wmc:StyeLayerDescriptor">
-
-          SLD=<xsl:value-of select="wmc:StyleList/wmc:Style[@current='1']/wmc:SLD/wmc:StyeLayerDescriptor"/>
-
-        </xsl:when>
-
-        <xsl:when test="wmc:StyleList/wmc:Style[@current='1']/wmc:SLD/wmc:FeatureTypeStyle">
-
-          SLD=<xsl:value-of select="wmc:StyleList/wmc:Style[@current='1']/wmc:SLD/wmc:FeatureTypeStyle"/>
-
-        </xsl:when>
-
-        <xsl:otherwise>
-
-          STYLES=<xsl:value-of select="wmc:StyleList/wmc:Style[@current='1']/wmc:Name"/>
-
-        </xsl:otherwise>
-
-      </xsl:choose>
-
-    </xsl:variable>
-
-    <xsl:variable name="visibility">
-
-      <xsl:choose>
-
-        <xsl:when test="@hidden='1'">hidden</xsl:when>
-
-        <xsl:otherwise>visible</xsl:otherwise>
-
-      </xsl:choose>
-
-    </xsl:variable>
-
-    <xsl:variable name="mapRequest">
-
-      <xsl:choose>
-
-        <xsl:when test="starts-with($version, '1.0')">
-
             WMTVER=<xsl:value-of select="$version"/>&amp;REQUEST=map
 
-        </xsl:when>            
+        </xsl:when><xsl:otherwise>
 
-        <xsl:otherwise>
-
             VERSION=<xsl:value-of select="$version"/>&amp;REQUEST=GetMap
 
-        </xsl:otherwise>
+        </xsl:otherwise></xsl:choose></xsl:variable><GetMap><mb:QueryString><xsl:variable name="src"><xsl:value-of select="$mapRequest"/>
 
-      </xsl:choose>
-
-    </xsl:variable>
-
-
-
-    <GetMap>
-
-      <mb:QueryString>
-
-        <xsl:variable name="src">    
-
-            <xsl:value-of select="$mapRequest"/>
-
    &amp;SRS=<xsl:value-of select="$srs"/>
 
   &amp;BBOX=<xsl:value-of select="$bbox"/>
@@ -248,33 +59,4 @@
 
 &amp;TRANSPARENT=true
 
-<!--	
-
-  //TBD: these still to be properly handled 
-
-  //also sld support
-
-  if (this.transparent) src += '&' + 'TRANSPARENT=' + this.transparent;
-
-	if (this.bgcolor) src += '&' + 'BGCOLOR=' + this.bgcolor;
-
-	//if (this.exceptions) src += '&' + 'EXCEPTIONS=' + this.exceptions;
-
-	if (this.vendorstr) src += '&' + this.vendorstr;
-
-  // -->
-
-        </xsl:variable>
-
-        <xsl:value-of select="translate(normalize-space($src),' ', '' )" disable-output-escaping="no"/>
-
-      </mb:QueryString>
-
-    </GetMap>
-
-  </xsl:template>
-
-
-
-</xsl:stylesheet>
-
+</xsl:variable><xsl:value-of select="translate(normalize-space($src),' ', '' )" disable-output-escaping="no"/></mb:QueryString></GetMap></xsl:template></xsl:stylesheet>
Index: lib/spatial/mapbuilder/lib/tool/xsl/wfs_Insert.xsl
===================================================================
--- lib/spatial/mapbuilder/lib/tool/xsl/wfs_Insert.xsl	(revision 4306)
+++ lib/spatial/mapbuilder/lib/tool/xsl/wfs_Insert.xsl	(revision 4307)
@@ -1,74 +1,2 @@
-<?xml version="1.0" encoding="ISO-8859-1"?>
-
-
-
-<!--
-
-Description: Extract FeatureMembers from a FeatureCollection and build
-
-  into a WFS Insert transaction.
-
-Author:      Cameron Shorter
-
-Licence:     LGPL as specified in http://www.gnu.org/copyleft/lesser.html .
-
-
-
-$Id$
-
-$Name$
-
--->
-
-
-
-<xsl:stylesheet version="1.0" 
-
-    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
-
-    xmlns:wfs="http://www.opengis.net/wfs"
-
-    xmlns:gml="http://www.opengis.net/gml">
-
-
-
-  <xsl:output method="xml" omit-xml-declaration="no" encoding="utf-8" indent="yes"/>
-
-
-
-  <!-- Match root -->
-
-  <xsl:template match="/">
-
-    <wfs:Transaction>
-
-      <wfs:Insert>
-
-        <xsl:apply-templates/>
-
-      </wfs:Insert>
-
-    </wfs:Transaction>
-
-  </xsl:template>
-
-
-
-  <!-- Match featureMember -->
-
-  <xsl:template match="gml:featureMember">
-
-    <xsl:for-each select="./*">
-
-      <xsl:copy-of select="."/>
-
-    </xsl:for-each>
-
-  </xsl:template>
-
-
-
-  <xsl:template match="text()|@*"/>
-
-</xsl:stylesheet>
-
+<?xml version="1.0"?>
+<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:wfs="http://www.opengis.net/wfs" xmlns:gml="http://www.opengis.net/gml" version="1.0"><xsl:output method="xml" omit-xml-declaration="yes" encoding="utf-8" indent="yes"/><xsl:template match="/"><wfs:Transaction service="WFS" version="1.0.0"><wfs:Insert><xsl:apply-templates/></wfs:Insert></wfs:Transaction></xsl:template><xsl:template match="gml:featureMember"><xsl:for-each select="./*"><xsl:copy-of select="."/></xsl:for-each></xsl:template><xsl:template match="text()|@*"/></xsl:stylesheet>
Index: lib/spatial/mapbuilder/lib/RELEASE.js
===================================================================
--- lib/spatial/mapbuilder/lib/RELEASE.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/RELEASE.js	(revision 4307)
@@ -0,0 +1,6 @@
+// This variable is set when script compression is used
+// It will disable dynamic script loading within MapBuilder
+// instead use the compressed file buil tfor that application
+
+var MapBuilder_Release = true
+//var baseDir = "../../lib"
\ No newline at end of file
Index: lib/spatial/mapbuilder/lib/tool/ToolBase.js
===================================================================
--- lib/spatial/mapbuilder/lib/tool/ToolBase.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/tool/ToolBase.js	(revision 4307)
@@ -1,6 +1,6 @@
 /*
 License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
-$Id$
+$Id: ToolBase.js 3881 2008-02-27 15:41:07Z gjvoosten $
 */
 
 /**
@@ -17,7 +17,7 @@
   //set the ID for this tool
   var id = toolNode.selectSingleNode("@id");
   if (id) {
-    this.id = id.firstChild.nodeValue;
+    this.id = getNodeValue(id);
   } else {
     this.id = "MbTool_" + mbIds.getId();
   }
@@ -31,9 +31,10 @@
     /** The model this tool will update. */
     var targetModel = toolRef.toolNode.selectSingleNode("mb:targetModel");
     if (targetModel) {
-      var targetModelName = targetModel.firstChild.nodeValue;
-      toolRef.targetModel = eval("config.objects."+targetModelName);
-      if (!toolRef.targetModel) alert("error finding targetModel:"+targetModelName+" for tool:"+toolRef.id);
+      var targetModelName = getNodeValue(targetModel);
+      //toolRef.targetModel = eval("config.objects."+targetModelName);
+      toolRef.targetModel = window.config.objects[targetModelName];
+      if (!toolRef.targetModel) alert(mbGetMessage("noTargetModelTool", targetModelName, toolRef.id));
     } else {
       toolRef.targetModel = toolRef.model;
     }
@@ -49,16 +50,24 @@
     /** Mouse handler which this tool will register listeners with. */
     var mouseHandler = toolRef.toolNode.selectSingleNode("mb:mouseHandler");
     if (mouseHandler) {
-      toolRef.mouseHandler = eval("config.objects." + mouseHandler.firstChild.nodeValue);
+      toolRef.mouseHandler = window.config.objects[getNodeValue(mouseHandler)];
       if (!toolRef.mouseHandler) {
-        alert("error finding mouseHandler:"+mouseHandler.firstChild.nodeValue+" for tool:"+toolRef.id);
+        alert(mbGetMessage("noMouseHandlerTool", getNodeValue(mouseHandler), toolRef.id));
       }
     }
   }
   this.model.addListener( "init", this.initMouseHandler, this );
 
+  /**
+   * Convenient access to Mapbuilder.getProperty
+   * @param property property to get
+   * @param default value to use if property is not set
+   * @return the value for the property
+   */
+  this.getProperty = function(property, defaultValue) {
+    return Mapbuilder.getProperty(toolNode, property, defaultValue);
+  }
+
   //tools enabled by default; can set to false in config for initial loading
-  this.enabled = true;
-  var enabled = toolNode.selectSingleNode("mb:enabled");
-  if (enabled) this.enabled = eval(enabled.firstChild.nodeValue);
+  this.enabled = Mapbuilder.parseBoolean(this.getProperty("mb:enabled", true));
 }
Index: lib/spatial/mapbuilder/lib/tool/Timer.js
===================================================================
--- lib/spatial/mapbuilder/lib/tool/Timer.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/tool/Timer.js	(revision 4307)
@@ -0,0 +1,61 @@
+/*
+License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
+Dependancies: Context
+$Id: Timer.js 3881 2008-02-27 15:41:07Z gjvoosten $
+*/
+
+// Ensure this object's dependancies are loaded.
+mapbuilder.loadScript(baseDir+"/tool/ToolBase.js");
+
+/**
+ * Timer to fire an event at the specified interval.  Any MapBuilder event name may be used,
+ * and the eventValue may be a funtion call which returns the expected value for setParam().
+ * @constructor
+ * @base ToolBase
+ * @author Adair
+ * @author Ian Turton
+ * @param toolNode The tool node from the config document for this tool
+ * @param model  the model object that contains this tool
+ */
+function Timer(toolNode, model) {
+  ToolBase.apply(this, new Array(toolNode, model));
+
+  //delay in milliseconds - defaults to every half hour
+  this.delay = 1000*this.getProperty("mb:every", 30);
+  
+  //set the event to be fired, default event is to reload the model
+  this.eventName = this.getProperty("mb:eventName", "reloadModel");
+  
+  //set the value to be passed with the event, default eventValue is null
+  this.eventValue = this.getProperty("mb:eventValue");
+  
+  /**
+   * Starts the timer playing by using a JavaScript timer.
+   */
+  this.play = function() {
+    clearInterval(this.interval);
+    var workString = "config.objects."+this.targetModel.id+".setParam('"+this.eventName+"'";
+    if (this.eventValue) workString += ","+this.eventValue;
+    workString += ")";
+  	//alert("about to set timer for "+this.delay+" millisecs: "+workString); 
+    this.interval = setInterval(workString,this.delay);
+  }
+
+  /**
+   * Stops the JavaScript timer.
+   */
+  this.stop = function() {
+    clearInterval(this.interval);
+  }
+
+  //the timer can start automatically or not, in which case there should be a call to timer.start() somewhere
+  this.autoStart = Mapbuilder.parseBoolean(this.getProperty("mb:autoStart", true));
+  this.startOnLoad = function(objRef) {
+    if (objRef.autoStart) objRef.play();
+  }
+  this.model.addListener("init",this.startOnLoad, this);
+  
+}
+
+
+
Index: lib/spatial/mapbuilder/lib/tool/xsl/wfs_Delete.xsl
===================================================================
--- lib/spatial/mapbuilder/lib/tool/xsl/wfs_Delete.xsl	(revision 4306)
+++ lib/spatial/mapbuilder/lib/tool/xsl/wfs_Delete.xsl	(revision 4307)
@@ -1,74 +1,2 @@
-<?xml version="1.0" encoding="ISO-8859-1"?>
-
-
-
-<!--
-
-Description: Extract FeatureMembers from a FeatureCollection and build
-
-  into a WFS Insert transaction.
-
-Author:      Cameron Shorter
-
-Licence:     LGPL as specified in http://www.gnu.org/copyleft/lesser.html .
-
-
-
-$Id$
-
--->
-
-
-
-<xsl:stylesheet version="1.0" 
-
-    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
-
-    xmlns:wfs="http://www.opengis.net/wfs"
-
-    xmlns:ogc="http://www.opengis.net/ogc"
-
-    xmlns:gml="http://www.opengis.net/gml">
-
-
-
-  <xsl:output method="xml" omit-xml-declaration="no" encoding="utf-8" indent="yes"/>
-
-
-
-  <!-- Match root -->
-
-  <xsl:template match="/">
-
-    <wfs:Transaction service="WFS" version="1.0.0">
-
-      <xsl:apply-templates/>
-
-    </wfs:Transaction>
-
-  </xsl:template>
-
-
-
-  <!-- Match featureMember -->
-
-  <xsl:template match="gml:featureMember/*[@fid]">
-
-    <wfs:Delete typeName="{name()}">
-
-      <ogc:Filter>
-
-        <ogc:FeatureId fid="{./@fid}"/>
-
-      </ogc:Filter>
-
-    </wfs:Delete>
-
-  </xsl:template>
-
-
-
-  <xsl:template match="text()|@*"/>
-
-</xsl:stylesheet>
-
+<?xml version="1.0"?>
+<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:wfs="http://www.opengis.net/wfs" xmlns:ogc="http://www.opengis.net/ogc" xmlns:gml="http://www.opengis.net/gml" version="1.0"><xsl:output method="xml" omit-xml-declaration="yes" encoding="utf-8" indent="yes"/><xsl:template match="/"><wfs:Transaction xmlns:topp="http://www.openplans.org/topp" service="WFS" version="1.0.0"><xsl:apply-templates/></wfs:Transaction></xsl:template><xsl:template match="gml:featureMember/*[@fid]"><wfs:Delete typeName="{name()}"><ogc:Filter><ogc:FeatureId fid="{./@fid}"/></ogc:Filter></wfs:Delete></xsl:template><xsl:template match="text()|@*"/></xsl:stylesheet>
Index: lib/spatial/mapbuilder/lib/tool/xsl/wfs_Transaction.xsl
===================================================================
--- lib/spatial/mapbuilder/lib/tool/xsl/wfs_Transaction.xsl	(revision 4306)
+++ lib/spatial/mapbuilder/lib/tool/xsl/wfs_Transaction.xsl	(revision 4307)
@@ -1,38 +1,2 @@
-<?xml version="1.0" encoding="ISO-8859-1"?>
-
-<!--
-Description: Extract FeatureMembers from a FeatureCollection and build
-  into a WFS Insert transaction.
-Author:      Cameron Shorter
-Licence:     LGPL as specified in http://www.gnu.org/copyleft/lesser.html .
-
-$Id$
-$Name$
--->
-
-<xsl:stylesheet version="1.0" 
-    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
-    xmlns:wfs="http://www.opengis.net/wfs"
-    xmlns:gml="http://www.opengis.net/gml"
-    xmlns:xlink="http://www.w3.org/1999/xlink">
-
-  <xsl:output method="xml" omit-xml-declaration="no" encoding="utf-8" indent="yes"/>
-
-  <!-- Match root -->
-  <xsl:template match="/">
-    <wfs:Transaction>
-      <wfs:Insert>
-        <xsl:apply-templates/>
-      </wfs:Insert>
-    </wfs:Transaction>
-  </xsl:template>
-
-  <!-- Match featureMember -->
-  <xsl:template match="gml:featureMember">
-    <xsl:for-each select="./*">
-      <xsl:copy-of select="."/>
-    </xsl:for-each>
-  </xsl:template>
-
-  <xsl:template match="text()|@*"/>
-</xsl:stylesheet>
+<?xml version="1.0"?>
+<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:wfs="http://www.opengis.net/wfs" xmlns:gml="http://www.opengis.net/gml" xmlns:xlink="http://www.w3.org/1999/xlink" version="1.0"><xsl:output method="xml" omit-xml-declaration="yes" encoding="utf-8" indent="yes"/><xsl:template match="/"><wfs:Transaction service="WFS" version="1.0.0"><wfs:Insert><xsl:apply-templates/></wfs:Insert></wfs:Transaction></xsl:template><xsl:template match="gml:featureMember"><xsl:for-each select="./*"><xsl:copy-of select="."/></xsl:for-each></xsl:template><xsl:template match="text()|@*"/></xsl:stylesheet>
Index: lib/spatial/mapbuilder/lib/tool/MergeModels.js
===================================================================
--- lib/spatial/mapbuilder/lib/tool/MergeModels.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/tool/MergeModels.js	(revision 4307)
@@ -0,0 +1,81 @@
+/*
+License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
+$Id: MergeModels.js 3881 2008-02-27 15:41:07Z gjvoosten $
+*/
+
+// Ensure this object's dependancies are loaded.
+mapbuilder.loadScript(baseDir+"/tool/ToolBase.js");
+
+/**
+ * Model that allows to merge multiple models into one. The first model
+ * determines the root node, other models are appended within the same
+ * root node.
+ * @constructor
+ * @base ToolBase
+ * @author Andreas Hocevar andreas.hocevarATgmail.com
+ * @param modelNode The model's XML object node from the configuration document
+ * @param model model this tool belongs to.
+ */
+function MergeModels(toolNode, model) {
+  // Inherit the ModelBase functions and parameters
+  ToolBase.apply(this, new Array(toolNode, model));
+  
+  this.template = null;
+
+  this.init = function(objRef) {
+    objRef.model.mergeModels = new Array();
+    var models = toolNode.selectSingleNode('mb:merges');
+    if (models) {
+      var model = models.childNodes;
+      for (var i = 0; i < model.length; i++) {
+        if (model[i].firstChild) {
+          objRef.addModel(objRef, config.objects[getNodeValue(model[i])]);
+        }
+      }
+    }
+  }
+  // it is important to be registered before other tools that
+  // check for model.mergeModels
+  model.addListener('init', this.init, this);
+  
+  this.getTemplate = function(objRef) {
+    objRef.template = objRef.model.doc ? objRef.model.doc.cloneNode(true) : null;
+    if (objRef.template) {
+      objRef.model.removeListener('loadModel', objRef.getTemplate, objRef);
+      objRef.buildModel(objRef);
+    }
+  }
+  model.addListener('loadModel', this.getTemplate, this);
+
+  this.addModel = function(objRef, model) {
+    objRef.model.mergeModels.push(model);
+    if (model.doc) {
+      objRef.mergeModel(objRef, model.doc);
+    }
+    model.addListener('refresh', objRef.buildModel, objRef);
+  }
+  
+  this.mergeModel = function(objRef, modelToMerge) {
+    var docToMerge = modelToMerge.doc ? modelToMerge.doc.cloneNode(true) : null;
+    var nodes = docToMerge ? docToMerge.selectNodes('//*[@fid]') : null;
+    if (!nodes) return;
+    var node;
+    for (var i=0; i<nodes.length; i++) {
+      node = nodes[i];
+      if (node.nodeName) {
+        node.setAttribute('sourceModel', modelToMerge.id);
+      }
+    }    
+    Sarissa.copyChildNodes(docToMerge.documentElement, objRef.model.doc.documentElement, true);
+  }
+  
+  this.buildModel = function(objRef) {
+    if (!objRef.template) return;
+    objRef.model.callListeners('newModel');
+    objRef.model.doc = objRef.template.cloneNode(true);
+    for (var i=0; i<objRef.model.mergeModels.length; i++) {
+      objRef.mergeModel(objRef, objRef.model.mergeModels[i]);
+    }
+    objRef.model.callListeners('loadModel');
+  }
+}
Index: lib/spatial/mapbuilder/lib/util/MGRS.js
===================================================================
--- lib/spatial/mapbuilder/lib/util/MGRS.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/util/MGRS.js	(revision 4307)
@@ -1,8 +1,8 @@
 /*
-Author:       Patrice G. Cappelaere (Got library from somewhere but cant remember where as it got translated several times)
+Author:       Patrice G. Cappelaere (Got library from Geoserver)
 License:      LGPL as per: http://www.gnu.org/copyleft/lesser.html
 
-$Id$
+$Id: MGRS.js 2546 2007-01-23 12:07:39Z gjvoosten $
 */
 
 
Index: lib/spatial/mapbuilder/lib/tool/History.js
===================================================================
--- lib/spatial/mapbuilder/lib/tool/History.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/tool/History.js	(revision 4307)
@@ -1,7 +1,7 @@
 /*
 Author:       Steven Ottens AT geodan.nl
 License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
-$Id$
+$Id: History.js 2956 2007-07-09 12:17:52Z steven $
 */
 
 // Ensure this object's dependancies are loaded.
@@ -19,29 +19,15 @@
 function History(toolNode, model) {
   ToolBase.apply(this, new Array(toolNode, model));
 
-	
-  var doAdd = new Boolean();
-
   /**
-    * Inititialising the history and setting start parameters
-    * @param objRef  pointer to this object.
-    */
+   * Inititialising the history and setting start parameters
+   * @param objRef  pointer to this object.
+   */
 
 	this.init = function(objRef) {
-    place = -1;
-    list = new Array();
-
-		var bbox = objRef.targetModel.getBoundingBox();
-    newExtent = new Array();
-    newExtent[0] = new Array(bbox[0],bbox[3]);
-    newExtent[1] = new Array(bbox[2],bbox[1]);
-		list.push(newExtent); 
-
-		place = place+1; 
-
-		objRef.model.active = place;
-    objRef.model.historyList = list;
-
+		objRef.model.active = -1;
+    objRef.model.historyList = new Array();
+    objRef.add(objRef);
   }
 
   /**
@@ -52,9 +38,20 @@
     if (objRef.model.active!=null) {
       var place = objRef.model.active;
       var list = objRef.model.historyList;
-      newExtent = new Array();
-      newExtent[0] = objRef.model.extent.ul;
-      newExtent[1] = objRef.model.extent.lr;
+      var center = objRef.targetModel.map.getExtent().getCenterLonLat();
+      // take the current scale -1, otherwise we get troubles when
+      // fixed scales are defined
+      var scale = objRef.targetModel.map.getScale()-1;
+      if (place > -1) {
+        // check if current and previous history entry would result
+        // in same center point and zoom level. If this is the case,
+        // we do not want a new entry in the list
+        if (center.toString() == list[place].center.toString() &&
+            scale == list[place].scale) {
+          return;
+        }
+      }
+      var newExtent = new Object({center:center, scale:scale});
 
       if( place==(list.length-1)) { //If we are already at the end of the list add a new item
         list.push(newExtent); 
@@ -76,10 +73,10 @@
    */
 
   this.back = function(objRef){
-    place = objRef.model.active;
+    var place = objRef.model.active;
     if(place<1) {
       objRef.model.previousExtent = null;
-      alert("You can't go further back");
+      alert(mbGetMessage("cantGoBack"));
     }
     else {
       place = place -1;
@@ -93,7 +90,7 @@
    * @param objRef  pointer to this object.
    */
   this.forward = function(objRef) {
-    place = objRef.model.active;
+    var place = objRef.model.active;
     if(place<(objRef.model.historyList.length-1)) {
       place = place +1;
       objRef.model.active = place;
@@ -101,7 +98,7 @@
     }
     else {
       objRef.model.nextExtent = null;
-      alert("You can't go further forward");
+      alert(mbGetMessage("cantGoForward"));
     }
   }
 
@@ -134,7 +131,4 @@
 	this.model.addListener("historyStart", this.start, this);
 	this.model.addListener("historyStop", this.stop, this);
 	this.model.addListener("init", this.initReset, this);
-}
-
-  
-  
+}
\ No newline at end of file
